# system_initiative_api_client
The API Server for interacting with a System Initiative workspace

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Generator version: 7.12.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com//.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com//.git`)

Then import the package:
```python
import system_initiative_api_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import system_initiative_api_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import system_initiative_api_client
from system_initiative_api_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = system_initiative_api_client.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with system_initiative_api_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = system_initiative_api_client.ActionsApi(api_client)
    workspace_id = 'workspace_id_example' # str | Workspace identifier
    change_set_id = 'change_set_id_example' # str | Change set identifier
    action_id = 'action_id_example' # str | Action identifier

    try:
        api_response = api_instance.cancel_action(workspace_id, change_set_id, action_id)
        print("The response of ActionsApi->cancel_action:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ActionsApi->cancel_action: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ActionsApi* | [**cancel_action**](docs/ActionsApi.md#cancel_action) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/actions/{action_id}/cancel | 
*ActionsApi* | [**get_actions**](docs/ActionsApi.md#get_actions) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/actions/ | 
*ActionsApi* | [**put_on_hold**](docs/ActionsApi.md#put_on_hold) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/actions/{action_id}/put_on_hold | 
*ActionsApi* | [**retry_action**](docs/ActionsApi.md#retry_action) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/actions/{action_id}/retry | 
*ChangeSetsApi* | [**abandon_change_set**](docs/ChangeSetsApi.md#abandon_change_set) | **DELETE** /v1/w/{workspace_id}/change-sets/{change_set_id} | 
*ChangeSetsApi* | [**create_change_set**](docs/ChangeSetsApi.md#create_change_set) | **POST** /v1/w/{workspace_id}/change-sets | 
*ChangeSetsApi* | [**force_apply**](docs/ChangeSetsApi.md#force_apply) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/force_apply | 
*ChangeSetsApi* | [**get_change_set**](docs/ChangeSetsApi.md#get_change_set) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id} | 
*ChangeSetsApi* | [**list_change_sets**](docs/ChangeSetsApi.md#list_change_sets) | **GET** /v1/w/{workspace_id}/change-sets | 
*ChangeSetsApi* | [**merge_status**](docs/ChangeSetsApi.md#merge_status) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/merge_status | 
*ChangeSetsApi* | [**purge_open**](docs/ChangeSetsApi.md#purge_open) | **POST** /v1/w/{workspace_id}/change-sets/purge_open | 
*ChangeSetsApi* | [**request_approval**](docs/ChangeSetsApi.md#request_approval) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/request_approval | 
*ComponentsApi* | [**add_action**](docs/ComponentsApi.md#add_action) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/components/{component_id}/action | 
*ComponentsApi* | [**create_component**](docs/ComponentsApi.md#create_component) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/components | 
*ComponentsApi* | [**delete_component**](docs/ComponentsApi.md#delete_component) | **DELETE** /v1/w/{workspace_id}/change-sets/{change_set_id}/components/{component_id} | 
*ComponentsApi* | [**execute_management_function**](docs/ComponentsApi.md#execute_management_function) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/components/{component_id}/execute-management-function | 
*ComponentsApi* | [**find_component**](docs/ComponentsApi.md#find_component) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/components/find | 
*ComponentsApi* | [**get_component**](docs/ComponentsApi.md#get_component) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/components/{component_id} | 
*ComponentsApi* | [**list_components**](docs/ComponentsApi.md#list_components) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/components | 
*ComponentsApi* | [**update_component**](docs/ComponentsApi.md#update_component) | **PUT** /v1/w/{workspace_id}/change-sets/{change_set_id}/components/{component_id} | 
*FuncsApi* | [**get_func**](docs/FuncsApi.md#get_func) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/funcs/{func_id} | 
*FuncsApi* | [**get_func_run**](docs/FuncsApi.md#get_func_run) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/funcs/runs/{func_run_id} | 
*RootApi* | [**system_status_route**](docs/RootApi.md#system_status_route) | **GET** / | 
*SchemasApi* | [**find_schema**](docs/SchemasApi.md#find_schema) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/schemas/find | 
*SchemasApi* | [**get_default_variant**](docs/SchemasApi.md#get_default_variant) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/schemas/{schema_id}/variant/default | 
*SchemasApi* | [**get_schema**](docs/SchemasApi.md#get_schema) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/schemas/{schema_id} | 
*SchemasApi* | [**get_variant**](docs/SchemasApi.md#get_variant) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/schemas/{schema_id}/variant/{schema_variant_id} | 
*SchemasApi* | [**list_schemas**](docs/SchemasApi.md#list_schemas) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/schemas | 
*SecretsApi* | [**create_secret**](docs/SecretsApi.md#create_secret) | **POST** /v1/w/{workspace_id}/change-sets/{change_set_id}/secrets | 
*SecretsApi* | [**delete_secret**](docs/SecretsApi.md#delete_secret) | **DELETE** /v1/w/{workspace_id}/change-sets/{change_set_id}/secrets/{secret_id} | 
*SecretsApi* | [**get_secrets**](docs/SecretsApi.md#get_secrets) | **GET** /v1/w/{workspace_id}/change-sets/{change_set_id}/secrets | 
*SecretsApi* | [**update_secret**](docs/SecretsApi.md#update_secret) | **PUT** /v1/w/{workspace_id}/change-sets/{change_set_id}/secrets/{secret_id} | 
*WhoamiApi* | [**whoami**](docs/WhoamiApi.md#whoami) | **GET** /whoami | 


## Documentation For Models

 - [ActionReference](docs/ActionReference.md)
 - [ActionReferenceOneOf](docs/ActionReferenceOneOf.md)
 - [ActionReferenceOneOf1](docs/ActionReferenceOneOf1.md)
 - [ActionV1RequestPath](docs/ActionV1RequestPath.md)
 - [ActionViewV1](docs/ActionViewV1.md)
 - [AddActionV1Request](docs/AddActionV1Request.md)
 - [AddActionV1Response](docs/AddActionV1Response.md)
 - [ApiError](docs/ApiError.md)
 - [ApiSuccessString](docs/ApiSuccessString.md)
 - [CancelActionV1Response](docs/CancelActionV1Response.md)
 - [ChangeSetViewV1](docs/ChangeSetViewV1.md)
 - [ComponentPropKey](docs/ComponentPropKey.md)
 - [ComponentPropViewV1](docs/ComponentPropViewV1.md)
 - [ComponentReference](docs/ComponentReference.md)
 - [ComponentReferenceOneOf](docs/ComponentReferenceOneOf.md)
 - [ComponentReferenceOneOf1](docs/ComponentReferenceOneOf1.md)
 - [ComponentV1RequestPath](docs/ComponentV1RequestPath.md)
 - [ComponentViewV1](docs/ComponentViewV1.md)
 - [Connection](docs/Connection.md)
 - [ConnectionDetails](docs/ConnectionDetails.md)
 - [ConnectionOneOf](docs/ConnectionOneOf.md)
 - [ConnectionOneOf1](docs/ConnectionOneOf1.md)
 - [ConnectionPoint](docs/ConnectionPoint.md)
 - [ConnectionViewV1](docs/ConnectionViewV1.md)
 - [ConnectionViewV1OneOf](docs/ConnectionViewV1OneOf.md)
 - [ConnectionViewV1OneOf1](docs/ConnectionViewV1OneOf1.md)
 - [ConnectionViewV1OneOf2](docs/ConnectionViewV1OneOf2.md)
 - [ConnectionViewV1OneOf3](docs/ConnectionViewV1OneOf3.md)
 - [CreateChangeSetV1Request](docs/CreateChangeSetV1Request.md)
 - [CreateChangeSetV1Response](docs/CreateChangeSetV1Response.md)
 - [CreateComponentV1Request](docs/CreateComponentV1Request.md)
 - [CreateComponentV1Response](docs/CreateComponentV1Response.md)
 - [CreateSecretV1Request](docs/CreateSecretV1Request.md)
 - [CreateSecretV1Response](docs/CreateSecretV1Response.md)
 - [DeleteChangeSetV1Response](docs/DeleteChangeSetV1Response.md)
 - [DeleteComponentV1Response](docs/DeleteComponentV1Response.md)
 - [DeleteSecretV1Response](docs/DeleteSecretV1Response.md)
 - [ErrorDetail](docs/ErrorDetail.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ExecuteManagementFunctionV1Request](docs/ExecuteManagementFunctionV1Request.md)
 - [ExecuteManagementFunctionV1Response](docs/ExecuteManagementFunctionV1Response.md)
 - [FindComponentV1Params](docs/FindComponentV1Params.md)
 - [FindSchemaV1Params](docs/FindSchemaV1Params.md)
 - [FindSchemaV1Response](docs/FindSchemaV1Response.md)
 - [ForceApplyChangeSetV1Response](docs/ForceApplyChangeSetV1Response.md)
 - [FuncRunLogViewV1](docs/FuncRunLogViewV1.md)
 - [FuncRunV1RequestPath](docs/FuncRunV1RequestPath.md)
 - [FuncRunViewV1](docs/FuncRunViewV1.md)
 - [GetActionsV1Response](docs/GetActionsV1Response.md)
 - [GetChangeSetV1Response](docs/GetChangeSetV1Response.md)
 - [GetComponentV1Response](docs/GetComponentV1Response.md)
 - [GetComponentV1ResponseActionFunction](docs/GetComponentV1ResponseActionFunction.md)
 - [GetComponentV1ResponseManagementFunction](docs/GetComponentV1ResponseManagementFunction.md)
 - [GetFuncRunV1Response](docs/GetFuncRunV1Response.md)
 - [GetFuncV1Response](docs/GetFuncV1Response.md)
 - [GetSchemaV1Response](docs/GetSchemaV1Response.md)
 - [GetSchemaVariantV1Response](docs/GetSchemaVariantV1Response.md)
 - [HashMapValue](docs/HashMapValue.md)
 - [IncomingConnectionViewV1](docs/IncomingConnectionViewV1.md)
 - [ListChangeSetV1Response](docs/ListChangeSetV1Response.md)
 - [ListComponentsV1Response](docs/ListComponentsV1Response.md)
 - [ListSchemaV1Response](docs/ListSchemaV1Response.md)
 - [ManagedByConnectionViewV1](docs/ManagedByConnectionViewV1.md)
 - [ManagementFunctionReference](docs/ManagementFunctionReference.md)
 - [ManagementFunctionReferenceOneOf](docs/ManagementFunctionReferenceOneOf.md)
 - [ManagementFunctionReferenceOneOf1](docs/ManagementFunctionReferenceOneOf1.md)
 - [ManagingConnectionViewV1](docs/ManagingConnectionViewV1.md)
 - [MergeStatusV1Response](docs/MergeStatusV1Response.md)
 - [MergeStatusV1ResponseAction](docs/MergeStatusV1ResponseAction.md)
 - [MergeStatusV1ResponseActionComponent](docs/MergeStatusV1ResponseActionComponent.md)
 - [OutgoingConnectionViewV1](docs/OutgoingConnectionViewV1.md)
 - [OutputLineViewV1](docs/OutputLineViewV1.md)
 - [PropSchemaV1](docs/PropSchemaV1.md)
 - [PurgeOpenChangeSetsV1Response](docs/PurgeOpenChangeSetsV1Response.md)
 - [PutOnHoldActionV1Response](docs/PutOnHoldActionV1Response.md)
 - [RequestApprovalChangeSetV1Response](docs/RequestApprovalChangeSetV1Response.md)
 - [RetryActionV1Response](docs/RetryActionV1Response.md)
 - [SchemaResponse](docs/SchemaResponse.md)
 - [SchemaV1RequestPath](docs/SchemaV1RequestPath.md)
 - [SchemaVariantV1RequestPath](docs/SchemaVariantV1RequestPath.md)
 - [SecretDefinitionV1](docs/SecretDefinitionV1.md)
 - [SecretFormDataV1](docs/SecretFormDataV1.md)
 - [SecretPropKey](docs/SecretPropKey.md)
 - [SecretV1](docs/SecretV1.md)
 - [SocketDirection](docs/SocketDirection.md)
 - [SocketViewV1](docs/SocketViewV1.md)
 - [SystemStatusResponse](docs/SystemStatusResponse.md)
 - [UpdateComponentV1Request](docs/UpdateComponentV1Request.md)
 - [UpdateComponentV1Response](docs/UpdateComponentV1Response.md)
 - [UpdateSecretV1Request](docs/UpdateSecretV1Request.md)
 - [UpdateSecretV1Response](docs/UpdateSecretV1Response.md)
 - [ViewV1](docs/ViewV1.md)
 - [WhoamiResponse](docs/WhoamiResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




