# coding: utf-8

"""
    System Initiative API

    The API Server for interacting with a System Initiative workspace

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from system_initiative_api_client.models.connection import Connection
from typing import Optional, Set
from typing_extensions import Self

class ConnectionDetails(BaseModel):
    """
    ConnectionDetails
    """ # noqa: E501
    add: Optional[List[Connection]] = None
    remove: Optional[List[Connection]] = None
    __properties: ClassVar[List[str]] = ["add", "remove"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConnectionDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in add (list)
        _items = []
        if self.add:
            for _item_add in self.add:
                if _item_add:
                    _items.append(_item_add.to_dict())
            _dict['add'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in remove (list)
        _items = []
        if self.remove:
            for _item_remove in self.remove:
                if _item_remove:
                    _items.append(_item_remove.to_dict())
            _dict['remove'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConnectionDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "add": [Connection.from_dict(_item) for _item in obj["add"]] if obj.get("add") is not None else None,
            "remove": [Connection.from_dict(_item) for _item in obj["remove"]] if obj.get("remove") is not None else None
        })
        return _obj


