# coding: utf-8

"""
    System Initiative API

    The API Server for interacting with a System Initiative workspace

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from system_initiative_api_client.models.component_view_v1 import ComponentViewV1
from system_initiative_api_client.models.get_component_v1_response_action_function import GetComponentV1ResponseActionFunction
from system_initiative_api_client.models.get_component_v1_response_management_function import GetComponentV1ResponseManagementFunction
from typing import Optional, Set
from typing_extensions import Self

class GetComponentV1Response(BaseModel):
    """
    GetComponentV1Response
    """ # noqa: E501
    action_functions: List[GetComponentV1ResponseActionFunction] = Field(alias="actionFunctions")
    component: ComponentViewV1
    management_functions: List[GetComponentV1ResponseManagementFunction] = Field(alias="managementFunctions")
    __properties: ClassVar[List[str]] = ["actionFunctions", "component", "managementFunctions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetComponentV1Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in action_functions (list)
        _items = []
        if self.action_functions:
            for _item_action_functions in self.action_functions:
                if _item_action_functions:
                    _items.append(_item_action_functions.to_dict())
            _dict['actionFunctions'] = _items
        # override the default output from pydantic by calling `to_dict()` of component
        if self.component:
            _dict['component'] = self.component.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in management_functions (list)
        _items = []
        if self.management_functions:
            for _item_management_functions in self.management_functions:
                if _item_management_functions:
                    _items.append(_item_management_functions.to_dict())
            _dict['managementFunctions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetComponentV1Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "actionFunctions": [GetComponentV1ResponseActionFunction.from_dict(_item) for _item in obj["actionFunctions"]] if obj.get("actionFunctions") is not None else None,
            "component": ComponentViewV1.from_dict(obj["component"]) if obj.get("component") is not None else None,
            "managementFunctions": [GetComponentV1ResponseManagementFunction.from_dict(_item) for _item in obj["managementFunctions"]] if obj.get("managementFunctions") is not None else None
        })
        return _obj


